﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace FluentETL.Impl
{
    public class DataReaderRow : IRow
    {
        private IDataReader Data { get; set; }

        public DataReaderRow(IDataReader dr)
        {
            this.Data = dr;
        }

        public object this[string key]
        {
            get
            {
                return this.Data[key];
            }
        }

        public IEnumerable<string> Fields
        {
            get
            {
                for (int i = 0; i < this.Data.FieldCount; i++)
                    yield return this.Data.GetName(i);
            }
        }

        public bool ContainsField(string field)
        {
            for (int i = 0; i < this.Data.FieldCount; i++)
                if (this.Data.GetName(i) == field)
                    return true;

            return false;
        }
    }
}
