﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace FluentETL.Impl
{
    public class ObjectRow: IRow
    {
        private object _obj;
        private IDictionary<string, PropertyInfo> _props;

        public ObjectRow(object o, IDictionary<string, PropertyInfo> props)
        {
            if (o == null)
                throw new InvalidOperationException("Cannot create object row from null.");
            _obj = o;
            _props = props;
        }

        public object this[string field]
        {
            get
            {
                return _props[field].GetValue(_obj, null);
            }
        }

        public IEnumerable<string> Fields
        {
            get
            {
                return _props.Keys;
            }
        }

        public bool ContainsField(string field)
        {
            return _props.ContainsKey(field);
        }
    }
}
